import 'package:freezed_annotation/freezed_annotation.dart';

part 'status.g.dart';

part 'status.freezed.dart';

///状态
@freezed
class IndicatorStatusModel with _$IndicatorStatusModel {
  const IndicatorStatusModel._();

  factory IndicatorStatusModel.none() = IndicatorStatusModelWithNone;

  factory IndicatorStatusModel.empty() = IndicatorStatusModelWithEmpty;

  factory IndicatorStatusModel.loadingMoreBusying() =
      IndicatorStatusModelWithLoadingMoreBusying;

  factory IndicatorStatusModel.fullScreenBusying() =
      IndicatorStatusModelWithFullScreenBusying;

  factory IndicatorStatusModel.error(
      {@JsonKey(
          fromJson: null,
          toJson: null,
          includeToJson: false,
          includeFromJson: false)
      Object? error,
      @JsonKey(
          fromJson: null,
          toJson: null,
          includeToJson: false,
          includeFromJson: false)
      StackTrace? stackTrace}) = IndicatorStatusModelWithError;

  factory IndicatorStatusModel.fullScreenError(
      {@JsonKey(
          fromJson: null,
          toJson: null,
          includeToJson: false,
          includeFromJson: false)
      Object? error,
      @JsonKey(
          fromJson: null,
          toJson: null,
          includeToJson: false,
          includeFromJson: false)
      StackTrace? stackTrace}) = IndicatorStatusModelWithFullScreenError;

  factory IndicatorStatusModel.noMoreLoad() =
      IndicatorStatusModelWithNoMoreLoad;

  factory IndicatorStatusModel.fromJson(Map<String, dynamic> json) =>
      _$IndicatorStatusModelFromJson(json);
}
